# Getting started

There are several starting points for Fable depending on your background:

- If you want to upgrade an existing Fable 1 project to Fable 2, [check the migration guide](/blog/Migration-to-Fable2.html).
- If you want have a quick taste without installing anything, [try the online REPL](/repl).
- If you're interested in F# both on client and server sides, check the [SAFE stack](https://safe-stack.github.io/).
- If you're new to F#, you may want to learn the basics of the language first. There are [many resources for that](https://fsharp.org/): a nice overview of the language is provided by [the tour of F#](https://docs.microsoft.com/en-us/dotnet/fsharp/tour) and for a more extensive guide you can check the enjoyable [tutorials by Scott Wlaschin](https://fsharpforfunandprofit.com/).
- When you're ready to start a Fable project in your computer you can clone the [Fable 2 minimal sample](https://github.com/fable-compiler/fable2-samples/tree/master/minimal) and check its README for more detailed instructions. For a more complex sample, check the [Fulma demo](https://github.com/MangelMaxime/fulma-demo).
- For more Fable examples, videos... check the [awesome-fable](https://github.com/kunjee17/awesome-fable) list of Fable resources.